﻿#include <iostream>
#include <vector>
using namespace std;

struct Input {
    vector <double> marks;
    int NCharts = 0;
};

Input
input_data() {
    Input in;
    int VecSize = 0;
    cin >> VecSize;
    in.marks.resize(VecSize);
    for (int i = 0; i < VecSize; i++) {
        cin >> in.marks[i];
    }
    cin >> in.NCharts;
    return in;
};

void FindMinMax(const vector<double>& marks, double & min, double & max) {
    max = 0;
    min = marks[0];
    for (double x : marks) {
        if (x > max) {
            max = x;
        }
        if (x < min) {
            min = x;
        }
    }
};

vector <double> MakeHistogram(const vector<double>& marks, int NCharts) {
    double interval = 0, i = 0, min = 0, max = 0;
    vector<double> chart(NCharts);
    FindMinMax(marks, min, max);
    interval = (max - min) / NCharts;
    for (int x : marks) {
        i = 0;
        while ((x > min + interval * (i + 1))) {
            i += 1;
        }
        chart[i] += 1;
    }
    return chart;
};

int main()
{
    const int shift = 4, maxlen = 80;
    Input in = input_data();
    int VecSize = size(in.marks);
    double interval = 0, inp = 0, i = 0, min = 0, max = 0, scale = 1;
    vector <double> chart = MakeHistogram(in.marks, in.NCharts);
    FindMinMax(chart, min, max);
    if ((max+shift) > maxlen) {
        scale = (max+shift) / maxlen;
    }
    for (i = 0; i < in.NCharts; i++) {
        if (chart[i] < 10) {
            cout << "  ";
        }
        else if (9 < chart[i] && chart[i]< 100) {
            cout << " ";
        }
        cout << chart[i] << "|";
        max = (chart[i] / scale);
        if (scale != 1) {
            max -= 1;
        }
        for (int j = 0; j < max; j++) {
            cout << "*";
        }
        cout << "\n";
    }
}

